// Macros

// Transformer une coordonne 3D flottante en une coordonne entire fentre 2D
#define XDM_to2D(fa, fmin, wmin, fcoef) (wmin + (int) ((fa - fmin) * fcoef))

// Transformer une coordonne entire fentre 2D en une coordonne 3D flottante
#define XDM_to3D(ia, fmin, wmin, fcoef)  (fmin + (ia - wmin) / fcoef)

// Arrondir une coordonne sur la grille
#define XDM_toGrid(fA) (((float) ((int) (fA / fGridSize))) * fGridSize)

// Dessiner un bouton et mmoriser le rectangle dans lequel il est inscrit
#define XDM_Bouton(gBouton, x, y)												\
	{																		\
		BitBlt(pWT -> hdcDBuf, x, y, 16, 9, gBouton.Gad -> hdc, 0, 0, SRCCOPY);	\
		gBouton.rect.left = x;												\
		gBouton.rect.top = y;												\
		gBouton.rect.right = x + 16;										\
		gBouton.rect.bottom = y + 9;										\
	}

// Vrifier si un point est dans le rectangle associ  un gadget
#define XDM_BoutonClic(GID, Point) PtInRect(&pWT -> Widgets[GID].rect, Point)

// Swapper les octets d'un long (les fichiers sont d'origine Amiga 68K)
#define swapl(x) \
	((((unsigned long) x & 0xFF000000) >> 24) |	\
     (((unsigned long) x & 0x00FF0000) >> 8)  | \
	 (((unsigned long) x & 0x0000FF00) << 8)  | \
     (((unsigned long) x & 0x000000FF) << 24))
